local TAG = "sandbox"

local AimStrategy = luajava.bindClass(GNS .. "Tower$AimStrategy")

local setupListener
local disposeListener

local sp
sp = scenarioPlayer:new()

-- Сценарий -----------------------------------

sp:addAction(0, function() -- Выполняется сразу (прошло 0 секунд)
    -- Выдаем много монет
    cmd.coins(100000)
    -- Показываем уведомление с подсказкой
    managers.UiManager.notifications:add("Press P or switch game speed to start the script", nil, nil, nil)
    -- Ставим игру на паузу - следующие действия не будут выполнены, пока игра не будет снята с паузы (время остановлено на 0)
    cmd.setgamespeed(0)
end)

sp:addAction(0.1, function() -- Выполняется через 0.1 секунд (почти сразу, как только игра была снята с паузы)
    -- Прячем интерфейс
    cmd.hideui()

    local Interpolation = luajava.bindClass("com.badlogic.gdx.math.Interpolation")
    systems.InputSystem.cameraController:animate(720.0, 1088.0, 0.75, 0.2, Interpolation.linear) -- 1108
end)

sp:addAction(2, function() -- Через N секунд
    -- С интервалом добавляем врагов на все тайлы в первом ряду карты, повторяем 100 раз
    local Interpolation = luajava.bindClass("com.badlogic.gdx.math.Interpolation")

    sp:addAction(3.5, function() -- Через N секунд 5
        systems.InputSystem.cameraController:animate(1733.9403, 1088.0, 1, 10, Interpolation.smooth) -- 8
    end)

    sp:addInterval(0.05, function()
        if utils.syncRandFloat() < 0.5 then
            cmd.addenemy(enums.EnemyType.REGULAR, 1.6, 70, 1, 10 + utils.syncRandInt(100), 20, 0, 10, -1)
        elseif utils.syncRandFloat() < 0.5 then
            cmd.addenemy(enums.EnemyType.FAST, 1.7, 40, 1, 10 + utils.syncRandInt(100), 20, 0, 8, -1)
        else
            cmd.addenemy(enums.EnemyType.STRONG, 1.5, 90, 1, 10 + utils.syncRandInt(100), 20, 0, 6, -1)
        end
    end, 500, nil)

    local actions = {
        { "B", enums.TowerType.BASIC, 3, 8 },
        { "B", enums.TowerType.BASIC, 4, 8 },
        { "B", enums.TowerType.BASIC, 5, 8 },
        { "B", enums.TowerType.BASIC, 6, 8 },
        { "W" },
        { "U", 3, 8 },
        { "U", 4, 8 },
        { "U", 6, 8 },
        { "B", enums.TowerType.BASIC, 8, 10 },
        { "U", 8, 10 },
        { "B", enums.TowerType.BASIC, 7, 8 },
        { "B", enums.TowerType.BASIC, 8, 8 },
        { "U", 8, 8 },
        { "U", 8, 8 },
        { "B", enums.TowerType.BASIC, 9, 6 },
        { "B", enums.TowerType.BASIC, 10, 6 },
        { "B", enums.TowerType.BASIC, 11, 6 },
        { "B", enums.TowerType.BASIC, 8, 7 },
        { "B", enums.TowerType.BASIC, 7, 10 },
        { "U", 3, 8 },
        { "U", 4, 8 },
        { "B", enums.TowerType.BASIC, 10, 9 },
        { "U", 5, 8 },
        { "B", enums.TowerType.BASIC, 10, 8 },
        { "B", enums.TowerType.SNIPER, 10, 10 },
        { "U", 10, 10 },
        { "U", 10, 10 },
        { "U", 10, 10 },
        { "U", 3, 8 },
        { "U", 4, 8 },
        { "B", enums.TowerType.BASIC, 12, 9 },
        { "B", enums.TowerType.BASIC, 12, 8 },
        { "B", enums.TowerType.BASIC, 12, 7 },
        { "U", 12, 7 },
        { "U", 12, 7 },
        { "U", 12, 7 },
        { "B", enums.TowerType.SNIPER, 13, 5 },
        { "U", 13, 5 },
        { "U", 13, 5 },
        { "B", enums.TowerType.BASIC, 14, 6 },
        { "B", enums.TowerType.BASIC, 15, 10 },
        { "U", 15, 10 },
        { "U", 15, 10 },
        { "B", enums.TowerType.BASIC, 15, 8 },
        { "B", enums.TowerType.BASIC, 16, 8 },
        { "B", enums.TowerType.BASIC, 18, 8 },
        { "U", 18, 8 },
        { "U", 18, 8 },
        { "B", enums.TowerType.BASIC, 15, 6 },
        { "U", 15, 6 },
        { "U", 15, 6 },
        { "U", 15, 6 },
        { "B", enums.TowerType.SNIPER, 22, 9 },
        { "U", 22, 9 },
        { "U", 22, 9 },
        { "U", 22, 9 },
        { "U", 22, 9 },
        { "B", enums.TowerType.SNIPER, 22, 7 },
        { "U", 22, 7 },
        { "U", 22, 7 },
        { "U", 22, 7 },
        { "B", enums.TowerType.BASIC, 17, 7 },
        { "B", enums.TowerType.SNIPER, 17, 6 },
        { "B", enums.TowerType.BASIC, 16, 4 },
        { "B", enums.TowerType.BASIC, 13, 11 },
        { "U", 13, 11 },
        { "U", 13, 11 },
        { "U", 13, 11 },
        { "B", enums.TowerType.BASIC, 20, 10 },
        { "B", enums.TowerType.BASIC, 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
        { "U", 20, 10 },
        { "U", 20, 6 },
    }
    local idx = 1

    local inst
    inst = sp:addInterval(0.19, function()
        local action = actions[idx]
        if action[1] == "B" then
            local tower = systems.TowerSystem:buildTower(action[2], AimStrategy.RANDOM, action[3], action[4])
            systems.TowerSystem:setAbilityInstalled(tower, 0, true)
            systems.TowerSystem:setAbilityInstalled(tower, 1, true)
            systems.TowerSystem:setAbilityInstalled(tower, 2, true)
        elseif action[1] == "U" then
            local tower = systems.MapSystem:getMap():getTile(action[2], action[3]).building
            systems.TowerSystem:upgradeTower(tower)
        end
        idx = idx + 1

        if idx > #actions then
            sp:removeInterval(inst)
        end
    end, 200, nil)
end)

-- ... и т.д.


local enemySystemListener = luajava.createProxy(GNS .. "systems.EnemySystem$EnemySystemListener", {
    enemyDie = function(enemy, tower, damageType, fromAbility)
        --[[
        -- Взрывающиеся враги
        local explosion = managers.ExplosionManager:getFactory(enums.ExplosionType.CANNON):obtain();

        explosion:setup(tower, enemy.position.x, enemy.position.y, enemy.maxHealth, 2, 0)
        systems.ExplosionSystem:register(explosion)
        explosion:explode()
        --]]
    end,

    enemyReachedTarget = function(enemy)
        systems.MapSystem:showTileWarningParticle(20, 8)
    end,

    affectsGameState = function() return true end,
    getConstantId = function() return 1000901 end
})

-- Конец сценария -----------------------------------

local updateListener = function(deltaTime)
    sp:update(deltaTime)
end

setupListener = function()
    addEventHandler("SystemUpdate", updateListener)
    addEventHandler("SystemDispose", disposeListener)

    systems.EnemySystem.listeners:add(enemySystemListener)
end

disposeListener = function()
    removeEventHandler("SystemUpdate", updateListener)
    removeEventHandler("SystemPostSetup", setupListener)
    removeEventHandler("SystemDispose", disposeListener)

    systems.EnemySystem.listeners:remove(enemySystemListener)
end

addEventHandler("SystemPostSetup", setupListener)